import numpy as np
import matplotlib
# matplotlib.use('TkAgg')
import matplotlib.pyplot as plt
from matplotlib.ticker import MaxNLocator
from collections import namedtuple
import os

n_groups = 10

Algos = ["LeNet-1", "LeNet-4", "LeNet-5", \
         "<200,200>", "<200,10>", "VGG-19", \
         "ResNet-50", "DAVE-2", \
         "ResNet56", "DenseNet121"]
# Algos = ["LR", "KMeans", "TPCH1", "TPCH4", "TPCH6","TPCH11","TPCH13","TPCH16","TPCH21"]
SYS = ["CW", "FGSM","PGD","GUSSIAN"]

# 	LR	Kmeans	SVM	TPCHQuery1	TPCHQuery3
# FLEX	na	na	na	0.1	1000

# Matryoshka	0.05	0.47	0.05	0.4	28
#correlation (no need to plot graph by level of attack, as it is captured by correlation)
#x: datasets
#y: correlations
#series: technique

#better use a table
cw = (0.085, 0.036, 0.061, 0.043, 0.096, 0.081, 0.02, 0.009, 0.018, 0.02)

fgsm = (0.065, 0.021, 0.019, 0.087, 0.089, 0.049, 0.073, 0.053, 0.004, 0.034)

pgd = (0.066, 0.077, 0.007, 0.018, 0.052, 0.09, 0.015, 0.061, 0.046, 0.08)

guassian = (0.0014, 0.0064, 0.009, 0.0026, 0.0095, 0.0023, 0.0079, 0.0075, 0.0081, 0.0081)

fig, ax = plt.subplots()

index = np.arange(n_groups)
bar_width = 0.35

opacity = 1

ax.set_yscale("log", nonposy='clip')

k = .50

bar_1 = ax.bar(index, cw, bar_width * k,
                alpha=opacity, color='#6495ED', edgecolor='#000000', hatch="...",label=SYS[0])

bar_2 = ax.bar(index + bar_width * k, fgsm, bar_width * k,
                  alpha=opacity, color='#FFBF00', edgecolor='#000000', yerr=0, hatch="\\\\", label=SYS[1])

bar_3 = ax.bar(index + bar_width * 2*k, pgd, bar_width * k,
                alpha=opacity, color='#9FE2BF', edgecolor='#000000', yerr=0, hatch= "-", label=SYS[2])

bar_4 = ax.bar(index + bar_width * 3*k, guassian, bar_width * k,
                alpha=opacity, color='#FF7F50', edgecolor='#000000', yerr=0, hatch="//",label=SYS[3])

#https://htmlcolorcodes.com/

ax.set_ylabel("Error on inferring\nFoP's Mean", fontsize=16)
ax.set_xlabel('DNN', fontsize=16)

ax.plot(range(0,10), [0.1 for i in range(0,10)], color='blue', linestyle='dashed', label="Accurate (< 10% error)")


# ax.plot(range(0,10), [10 for i in range(0,10)], color='blue', linestyle='dashed', label="High utility (< 10% error)")

# ax.text(-0.55, 6e-10, "0.0",fontsize=13)
# # ax.text(0.55, 6e-10, "0.0",fontsize=8)
# ax.text(5.4, 6e-10, "N/A",fontsize=13)
# ax.text(6.4, 6e-10, "N/A",fontsize=13)
# ax.text(7.4, 6e-10, "N/A",fontsize=13)
# ax.text(8.4, 6e-10, "N/A",fontsize=13)

ax.tick_params(axis='x', which='major', labelsize=16)
ax.tick_params(axis='y', which='major', labelsize=16)
# ax.set_yticks(np.arange(0,10^4))
# ax.set_yticklabels(np.arange(1,8))
ax.set_xticks(index + bar_width * .27)
ax.set_xticklabels(Algos, rotation=90)
ax.legend(loc='lower right', fontsize=14)

fig.tight_layout()
plt.savefig(os.path.basename(__file__).replace(".py", ".pdf"))