import numpy as np
import matplotlib
# matplotlib.use('TkAgg')
import matplotlib.pyplot as plt
from matplotlib.ticker import MaxNLocator
from collections import namedtuple
import os

n_groups = 10

Algos = ["LeNet-1", "LeNet-4", "LeNet-5", \
         "<200,200>", "<200,10>", "VGG-19", \
         "ResNet-50", "DAVE-2", \
         "ResNet56", "DenseNet121"]
# Algos = ["LR", "KMeans", "TPCH1", "TPCH4", "TPCH6","TPCH11","TPCH13","TPCH16","TPCH21"]
SYS = ["Themis", "DeepXplore","DeepGauge","DeepImportance","Surprise Adequacy\nfor DL systems"]

# 	LR	Kmeans	SVM	TPCHQuery1	TPCHQuery3
# FLEX	na	na	na	0.1	1000

# Matryoshka	0.05	0.47	0.05	0.4	28
#correlation (no need to plot graph by level of attack, as it is captured by correlation)
#x: datasets
#y: correlations
#series: technique

#better use a table
dd = (13639, 15575, 11198, 16644, 15057, 15033, 11655, 19752, 10194, 13074)

nc = (932, 1928, 1896, 881, 1374, 968, 1905, 1968, 1887, 1429)

dg = (103, 145, 115, 156, 160, 147, 193, 159, 172, 169)

idc = (180, 109, 184, 163, 153, 114, 195, 180, 107, 111)

sa = (120, 108, 140, 127, 138, 147, 112, 130, 125, 103)

fig, ax = plt.subplots()

index = np.arange(n_groups)
bar_width = 0.35

opacity = 1

ax.set_yscale("log", nonposy='clip')

k = .50

bar_1 = ax.bar(index, dd, bar_width * k,
                alpha=opacity, color='r', edgecolor='#000000', hatch="...",label=SYS[0])

bar_2 = ax.bar(index + bar_width * k, nc, bar_width * k,
                  alpha=opacity, color='#5DADE2', edgecolor='#000000', yerr=0, hatch="\\\\", label=SYS[1])

bar_3 = ax.bar(index + bar_width * 2*k, dg, bar_width * k,
                alpha=opacity, color='#F4D03F', edgecolor='#000000', yerr=0, hatch= "-", label=SYS[2])

bar_4 = ax.bar(index + bar_width * 3*k, idc, bar_width * k,
                alpha=opacity, color='#58D68D', edgecolor='#000000', yerr=0, hatch="//",label=SYS[3])
    
bar_5 = ax.bar(index + bar_width * 4*k, sa, bar_width * k,
                alpha=opacity, color='#A569BD', edgecolor='#000000', yerr=0, hatch=".",label=SYS[4])

#https://htmlcolorcodes.com/

ax.set_ylabel('Fréchet inception distance', fontsize=16)
ax.set_xlabel('Datasets' ,fontsize=16)

# ax.plot(range(0,10), [0.1 for i in range(0,10)], color='blue', linestyle='dashed', label="Accurate (< 10% error)")


# ax.plot(range(0,10), [10 for i in range(0,10)], color='blue', linestyle='dashed', label="High utility (< 10% error)")

# ax.text(-0.55, 6e-10, "0.0",fontsize=13)
# # ax.text(0.55, 6e-10, "0.0",fontsize=8)
# ax.text(5.4, 6e-10, "N/A",fontsize=13)
# ax.text(6.4, 6e-10, "N/A",fontsize=13)
# ax.text(7.4, 6e-10, "N/A",fontsize=13)
# ax.text(8.4, 6e-10, "N/A",fontsize=13)

ax.tick_params(axis='x', which='major', labelsize=16)
ax.tick_params(axis='y', which='major', labelsize=16)
# ax.set_yticks(np.arange(0,10^4))
# ax.set_yticklabels(np.arange(1,8))
ax.set_xticks(index + bar_width * .27)
ax.set_xticklabels(Algos, rotation=90)
ax.legend(loc='lower right', fontsize=16)

fig.tight_layout()
plt.savefig(os.path.basename(__file__).replace(".py", ".pdf"))