import numpy as np
import matplotlib
# matplotlib.use('TkAgg')
import matplotlib.pyplot as plt
from matplotlib.ticker import MaxNLocator
from collections import namedtuple
import os

n_groups = 5

# Algos = ["MNIST(LeNet-1)", "MNIST(LeNet-4)", "MNIST(LeNet-5)", \
#          "MNIST(FCNet5)", "MNIST(FCNet10)", "ImageNet(VGG-19)", \
#          "ImageNet(ResNet-50)", "Udacity (DAVE-2)", \
#          "ResNet56 (Cifar10)", "DenseNet121 (Cifar10)"]
# Algos = ["LR", "KMeans", "TPCH1", "TPCH4", "TPCH6","TPCH11","TPCH13","TPCH16","TPCH21"]
xlabels = ["$10^{1}$", \
       "$10^{2}$", \
       "$10^{3}$", \
       "$10^{4}$", \
       "$10^{5}$"]

colours = ['tab:blue','tab:orange','tab:green','tab:red',\
           'tab:purple','tab:brown','tab:pink','tab:gray', \
           'tab:olive','tab:cyan']
markers=['o','v','^','p','3','2','s','p','1','*']
# 	LR	Kmeans	SVM	TPCHQuery1	TPCHQuery3
# FLEX	na	na	na	0.1	1000

# Matryoshka	0.05	0.47	0.05	0.4	28
#correlation (no need to plot graph by level of attack, as it is captured by correlation)
#x: datasets
#y: correlations
#series: technique

#better use a table
ss = {
    "MNIST(LeNet-1)":        [0.06,0.36,0.96,0.91,0.97],
    "MNIST(LeNet-4)":        [0.04,0.31,0.99,0.92,0.90],
    "MNIST(LeNet-5)":        [0.18,0.50,0.92,1.00,0.94],
    "MNIST(FCNet5)":         [0.12,0.31,0.95,0.98,0.93],
    "MNIST(FCNet10)":        [0.11,0.17,0.98,0.96,0.98],
    "ImageNet(VGG-19)":      [0.02,0.32,0.91,0.95,0.91],
    "ImageNet(ResNet-50)":   [0.12,0.46,1.00,0.90,0.95],
    "Udacity (DAVE-2)":      [0.06,0.42,0.97,0.90,0.98],
    "ResNet56 (Cifar10)":    [0.07,0.39,0.97,0.91,0.97],
    "DenseNet121 (Cifar10)": [0.08,0.41,0.99,0.95,0.90],

}

fig, ax = plt.subplots()

index = np.arange(n_groups)
bar_width = 0.35

opacity = 1

ax.set_yscale("log", nonposy='clip')

k = .50

counter = 0
for datasets in ss:
    plt.plot(range(0,len(xlabels)),ss[datasets],\
             marker=markers[counter],label=datasets,color=colours[counter])
    counter = counter + 1
# bar_1 = ax.bar(index, ss1, bar_width * k,
#                 alpha=opacity, color='#FF3933', edgecolor='#000000', hatch="...",label=SYS[0])
#
# bar_2 = ax.bar(index + bar_width * k, ss2, bar_width * k,
#                   alpha=opacity, color='#ffbfc0', edgecolor='#000000', yerr=0, hatch="\\\\", label=SYS[1])
#
# bar_3 = ax.bar(index + bar_width * 2*k, ss3, bar_width * k,
#                 alpha=opacity, color='#96c6d0', edgecolor='#000000', yerr=0, hatch= "-", label=SYS[2])
#
# bar_4 = ax.bar(index + bar_width * 3*k, ss4, bar_width * k,
#                 alpha=opacity, color='#bfc0ff', edgecolor='#000000', yerr=0, hatch="//",label=SYS[3])
#
# bar_5 = ax.bar(index + bar_width * 4*k, ss5, bar_width * k,
#                 alpha=opacity, color='#bfc0ff', edgecolor='#000000', yerr=0, hatch="//",label=SYS[4])

ax.set_xlabel('Sample Size', fontsize=18)
ax.set_ylabel('Coverage Rate (%)', fontsize=16)
ax.plot(range(0,5), [1.0 for i in range(0,5)], color='blue', linestyle='dashed', label="Ground Truth")
# ax.plot(range(0,10), [0.1 for i in range(0,10)], color='blue', linestyle='dashed', label="Accurate (< 10% error)")


# ax.plot(range(0,10), [10 for i in range(0,10)], color='blue', linestyle='dashed', label="High utility (< 10% error)")

# ax.text(-0.55, 6e-10, "0.0",fontsize=13)
# # ax.text(0.55, 6e-10, "0.0",fontsize=8)
# ax.text(5.4, 6e-10, "N/A",fontsize=13)
# ax.text(6.4, 6e-10, "N/A",fontsize=13)
# ax.text(7.4, 6e-10, "N/A",fontsize=13)
# ax.text(8.4, 6e-10, "N/A",fontsize=13)

ax.tick_params(axis='x', which='major', labelsize=13)
ax.tick_params(axis='y', which='major', labelsize=15)
# ax.set_yticks(np.arange(0,10^4))
# ax.set_yticklabels(np.arange(1,8))
ax.set_xticks(index + bar_width * .27)
ax.set_xticklabels(xlabels, rotation=40)
ax.legend(loc='lower right', fontsize=10)

fig.tight_layout()
plt.savefig(os.path.basename(__file__).replace(".py", ".pdf"))