import numpy as np
import matplotlib.pyplot as plt
from matplotlib.ticker import MaxNLocator
from collections import namedtuple
import os

n_groups = 10

Algos = ["TPCH1", "TPCH4", "TPCH13", "TPCH16","TPCH21", "","KMEANS", "LR", "TPCH6","TPCH11"]
# Algos = ["LR", "KMeans", "TPCH1", "TPCH4", "TPCH6","TPCH11","TPCH13","TPCH16","TPCH21"]
SYS = ["FLEX", "UPA"]

# 	LR	Kmeans	SVM	TPCHQuery1	TPCHQuery3
# FLEX	na	na	na	0.1	1000
					
# Matryoshka	0.05	0.47	0.05	0.4	28

flex_data = (0.0, 7.1, 56.2, 851.1380382, 1453754.5, 0, 0.0, 0.0,  0.0, 0.0)

upa_data = (2.63102E-09, 0.001001893, 0.606585789, 0.000226425, 29.88582942, 0, 4.53382E-08, 3.53382E-07, 1.83567E-06, 1.67696E-08)

fig, ax = plt.subplots()

index = np.arange(n_groups)
bar_width = 0.35

opacity = 1

ax.set_yscale("log", nonposy='clip')

k = .50
flex_bar = ax.bar(index, flex_data, bar_width * k,
                alpha=opacity, color='#FEFFBF', edgecolor='#000000', label=SYS[0])

ss_bar = ax.bar(index + bar_width * k, upa_data, bar_width * k,
                alpha=opacity, color='#ffbfc0', edgecolor='#000000', label=SYS[1], hatch="//")

ax.set_xlabel('Application', fontsize=18)
ax.set_ylabel('Log Root Mean Square Error (%)', fontsize=16)

ax.text(-0.55, 6e-10, "0.0",fontsize=13)
# ax.text(0.55, 6e-10, "0.0",fontsize=8)
ax.text(5.4, 6e-10, "N/A",fontsize=13)
ax.text(6.4, 6e-10, "N/A",fontsize=13)
ax.text(7.4, 6e-10, "N/A",fontsize=13)
ax.text(8.4, 6e-10, "N/A",fontsize=13)
ax.tick_params(axis='x', which='major', labelsize=13)
ax.tick_params(axis='y', which='major', labelsize=15)
# ax.set_yticks(np.arange(1,8))
# ax.set_yticklabels(np.arange(1,8))
ax.set_xticks(index + bar_width * .27)
ax.set_xticklabels(Algos,rotation=40)
ax.legend(loc='upper left',fontsize=15)

fig.tight_layout()
plt.savefig(os.path.basename(__file__).replace(".py", ".pdf"))