import matplotlib
# matplotlib.use('agg')
import matplotlib.pyplot as plt
import pandas as pd
import os
q = {
    "LR":[71.4,72.5,72.1,94.9],
    "KM":[88.6,97.9,90.8,109.1],
    "TPCH1":[126.8,126.6,133.7,162.1],
    "TPCH4":[59.0,56.6,54.0,57.3],
    "TPCH6":[120.6,134.8,136.3,126.6],
    "TPCH11":[43.6,43.5,42.2,45.4],
    "TPCH13":[107.9,108.6,108.8,120.0],
    "TPCH16":[56.5,51.4,56.1,56.3],
    "TPCH21":[25.9,22.9,25.9,26.7]
}
x_label = ['$10^2$','$10^3$','$10^4$','$10^5$']
# colours = ['tab:blue','tab:orange','tab:green','tab:red','tab:purple']
colours = ['tab:blue','tab:orange','tab:green','tab:red',\
           'tab:purple','tab:brown','tab:pink','tab:gray', \
           'tab:olive','tab:cyan']
markers=['o','v','^','p','3','2','s','p','1']
#markers=["ro-","bv-","c^-","mp-","ys-","g3-","o2-",""]
counter = 0
for key in q:
    plt.plot(range(0,len(x_label)),q[key],marker=markers[counter],label=key,color=colours[counter])
    counter = counter + 1
plt.xticks(range(0,len(x_label)),x_label)
plt.ylabel("Performance Overhead", fontsize=15)
plt.xlabel("Sample size", fontsize=15)
plt.tick_params(axis='x', which='major', labelsize=15)
plt.tick_params(axis='y', which='major', labelsize=15)
plt.legend(loc='center right', fontsize=15)
# plt.show()
plt.savefig(os.path.basename(__file__).replace(".py", ".pdf"))